package src.ship

import akka.actor.ActorDSL._
import java.io.FileWriter
import scala.swing.{Font, TextArea}

/**
 * Created with IntelliJ IDEA.
 * User: maeder
 * Date: 10.10.13
 * Time: 17:04
 */

class LogPane(textfont: Font) extends TextArea(20, 70) {
  editable = false
  focusable = true
  font = textfont
  val logfile = new FileWriter("shiplog.txt")

  text = "** ship Engine Room ** \nType 'help' for help\n"

  def log(msg: Any) {
    val newMsg = msg.toString + "\n"
    var newtext = text + newMsg
    while (newtext.split("\n").size > 200) {
      newtext = newtext.substring(newtext.indexOf("\n") + 1)
    }
    text_=(newtext)
    caret.position = text.length
    logfile.write(newMsg)
    logfile.flush()
  }
}

class SHIPRoomLog(lp: LogPane) extends ActWithStash {
  override def receive = {
    case CurrentOntology(o) => lp.log("New Abox: " + o)
    case CurrentTrace(t) => lp.log("Trace:\n======\n" + t.toString())
    case ProgramUpdateAbox(p, res) => lp.log("Program " + p + " updated abox to " + res)
    case ProgramError(p, msg) => lp.log("ProgramError " + p.toString + ": " + msg)
    case ProgramFailure(p) => lp.log("Program terminate with failure " + p)
    case MonitorFailure(phi, desc, last, current, currentresult) =>
      lp.log("Monitor failure [" + desc + ":" + phi + "] current " +
        current + "=" + currentresult)
    case MonitorSuccess(phi, value, dsc) => lp.log("Monitor successfully terminated " + phi)
    case DeclarationAdded(s) =>
      lp.log("Added declarations for " + s)
    case Log(s) => lp.log(s)
    case s: String => lp.log(s)
    case _ =>
  }
}
