package src.test;

import aterm.AFun;
import aterm.ATermAppl;
import aterm.ATermFactory;
import com.clarkparsia.pellet.owlapiv3.PelletReasoner;
import org.mindswap.pellet.utils.ATermUtils;
import org.semanticweb.owlapi.apibinding.OWLManager;
import org.semanticweb.owlapi.model.OWLDataFactory;
import org.semanticweb.owlapi.model.OWLOntology;
import org.semanticweb.owlapi.model.OWLOntologyCreationException;
import org.semanticweb.owlapi.model.OWLOntologyManager;


/**
 * Created by IntelliJ IDEA.
 * User: dodi
 * Date: 7/17/12
 * Time: 2:12 PM
 * To change this template use File | Settings | File Templates.
 */
public class InstanceTest4 {
    public static void main(String[] args) throws OWLOntologyCreationException {
        // we create an empty ontology and do not use namespaces...
        OWLOntologyManager manager = OWLManager.createOWLOntologyManager();
		OWLDataFactory factory = manager.getOWLDataFactory();
        //OWLOntology ontology = manager.createOntology(IRI.create("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl"));
        OWLOntology ontology = manager.createOntology();
        PelletReasoner reasoner = new PelletReasoner( ontology, org.semanticweb.owlapi.reasoner.BufferingMode.NON_BUFFERING );

        ATermFactory aTermFactory = new aterm.pure.PureFactory();


        // we add a class
        reasoner.getKB().addClass(ATermUtils.makeTermAppl("Set1"));
        reasoner.getKB().addClass(ATermUtils.makeTermAppl("Set2"));
        // we add an individual
        ATermAppl newind = ATermUtils.makeTermAppl("sX");
        reasoner.getKB().addIndividual( newind );
        reasoner.getKB().addType(newind, ATermUtils.makeTermAppl("Set1"));
        reasoner.getKB().addType(newind, ATermUtils.makeTermAppl("Set2"));

        ATermAppl newind2 = ATermUtils.makeTermAppl("sY");
        reasoner.getKB().addIndividual( newind2 );
        reasoner.getKB().addType(newind2, ATermUtils.makeTermAppl("Set1"));
        reasoner.getKB().addType(newind2, ATermUtils.makeTermAppl("Set2"));

        ATermAppl newind3 = ATermUtils.makeTermAppl("s1");
        reasoner.getKB().addIndividual( newind3 );
        reasoner.getKB().addType(newind3, ATermUtils.makeTermAppl("Set1"));

        ATermAppl newind4 = ATermUtils.makeTermAppl("s2");
        reasoner.getKB().addIndividual( newind4);
        reasoner.getKB().addType(newind4, ATermUtils.makeTermAppl("Set2"));

         // and action...
        reasoner.getKB().realize();
        reasoner.getKB().printClassTree();
        reasoner.prepareReasoner();

        ATermAppl internSet1 = ATermUtils.makeTermAppl("Set1");
        ATermAppl internSet2 = ATermUtils.makeTermAppl("Set2");

        ATermAppl internSet12 = ATermUtils.makeAnd(internSet1, internSet2);
        ATermAppl internSet21 = ATermUtils.makeAnd(internSet2, internSet1);
        System.out.println("instances of "+internSet1+" "+reasoner.getKB().getInstances( internSet1, false));
        System.out.println("instances of "+internSet2+" "+reasoner.getKB().getInstances( internSet2, false));
        System.out.println("instances of "+internSet12+" "+reasoner.getKB().getInstances( internSet12, false));
        System.out.println("instances of "+internSet21+" "+reasoner.getKB().getInstances( internSet21, false));


        /*// check for sparql query
        // Get the KB from the reasoner
		KnowledgeBase kb = owlapiReasoner.getKB();
		// Create Pellet-Jena reasoner
		PelletReasoner jenaReasoner = new PelletReasoner();
		// Create a Pellet graph using the KB from OWLAPI
		PelletInfGraph graph = jenaReasoner.bind( kb );
		// Wrap the graph in a model
		Model model = ModelFactory.createInfModel( graph );
		// Create a query execution over this model
		QueryExecution qe = SparqlDLExecutionFactory.create(query, model );*/
    }
}
