package src.test

import com.clarkparsia.pellet.owlapiv3.PelletReasonerFactory
import de.derivo.sparqldlapi._
import java.io.{File, FileReader}
import org.semanticweb.owlapi.apibinding.OWLManager
import org.semanticweb.owlapi.model.OWLOntologyManager
import org.semanticweb.owlapi.reasoner.OWLReasoner
import src.ship._

/**
 * Created with IntelliJ IDEA.
 * User: dodi
 * Date: 04.09.12
 * Time: 13:18
 */

object SPARQLScala extends OntologyParser {
  def main(args: Array[String]) {
    val manager: OWLOntologyManager = OWLManager.createOWLOntologyManager()
    val pm = Builtin.prefixManager
    // Load the wine ontology from the web.
    parseAll(ontology, new FileReader(new File("examples/baall/baal.ont"))) match {
      case Success(ont, _) =>
        var owlont = Ontology2OWL.convert(ont, pm, manager)
        val factory = new PelletReasonerFactory()
        val reasoner: OWLReasoner = factory.createReasoner(owlont)
        /*val squery:Query= Query.create("PREFIX ship: <"+prefix+">\n"+
          "SELECT ?wc2 WHERE {\n"
            +" Class(?wc2), DirectSubClassOf(ship:Off,?wc2)}");*/

        val squery: Query = Query.create("PREFIX ship: <" + Builtin.namespace + ">\n" +
          " ASK { Type(ship:bathroomLight,ship:On)}")
        // "SELECT ?c WHERE {\n"
        //+" Type(ship:livingLight3,?c)}");
        val engine: QueryEngine = QueryEngine.create(manager, reasoner, true)
        val result: QueryResult = engine.execute(squery)
        println(result)
        println(reasoner.getTypes(manager.getOWLDataFactory.getOWLNamedIndividual(":" + "livingLight3", Builtin.prefixManager), false))
        println(OWLQuery.queryResult2Substitution(result, squery))
        println("internal:")
        println(OWLQuery.getDirectSuperClasses(ConceptConstant("Off"), manager, reasoner, Builtin.namespace))
      case NoSuccess(msg, _) => println("parse failure: " + msg)
    }
  }
}
