package src.test

import com.clarkparsia.pellet.owlapiv3.PelletReasoner
import de.derivo.sparqldlapi.{QueryResult, Query, QueryEngine}
import java.io.{File, FileReader}
import org.semanticweb.owlapi.apibinding.OWLManager
import org.semanticweb.owlapi.model.{OWLOntology, IRI, OWLOntologyManager}
import src.ship._

/**
 * Created by IntelliJ IDEA.
 * User: dodi
 * Date: 7/24/12
 * Time: 9:12 AM
 */

object SparQLNegation extends OntologyParser {
  def main(args: Array[String]) {
    // Create an ontology manager
    val manager: OWLOntologyManager = OWLManager.createOWLOntologyManager()

    parseAll(ontology, new FileReader(new File("examples/baall/transport6.ont"))) match {
      case Success(ont, in) =>
        val owlont: OWLOntology = manager.loadOntologyFromOntologyDocument(IRI.create("file:examples/transport.owl"))

        println(Ontology2OWL.computeTopClasses(owlont))

        val reasoner2 = new PelletReasoner(owlont, org.semanticweb.owlapi.reasoner.BufferingMode.NON_BUFFERING)
        reasoner2.prepareReasoner()
        reasoner2.getKB.realize()
        val prefix = "PREFIX ship: <" + Builtin.namespace + ">\n"

        val querystring = prefix +
          "SELECT ?x WHERE {\n" +
          "Individual(?x) " +
          ", Type(?x, ?y)" +
          ", ComplementOf(?y, ship:Position)" +
          "}"

        val querystring2 = prefix +
          "SELECT ?y WHERE {\n" +
          "ComplementOf(?y, ship:Position)" +
          "}"

        val querystring3 = prefix +
          "ASK {\n" +
          "ComplementOf(ship:WheelChair, ship:Position)" +
          "}"

        // Create an instance of the SPARQL-DL query engine
        val engine: QueryEngine = QueryEngine.create(manager, reasoner2, true)

        parseAll(aboxformula, "r:Free") match {
          case Success(s2, in2) =>
            //val q:Query = OWLQuery.aBoxFormulas2Query(List[ABoxFormula](s2),Builtin.namespace )
            val q: Query = Query.create(querystring)
            var result: QueryResult = engine.execute(q)

            val q2: Query = Query.create(querystring2)
            var result2: QueryResult = engine.execute(q2)

            val q3: Query = Query.create(querystring3)
            var result3: QueryResult = engine.execute(q3)

            println(OWLQuery.queryResult2Substitution(result, q))
            println(q.isAsk + " " + result.ask())
            println(OWLQuery.queryResult2Substitution(result2, q2))
            println(q2.isAsk + " " + result2.ask())
            println(OWLQuery.queryResult2Substitution(result3, q3))
            println(q3.isAsk + " " + result3.ask())
          case NoSuccess(msg, _) => println("parse failure: " + msg)
        }
      case NoSuccess(msg, _) => println("parse failure: " + msg)
    }
  }
}
