package src.test;

import com.clarkparsia.pellet.owlapiv3.PelletReasonerFactory;
import de.derivo.sparqldlapi.Query;
import de.derivo.sparqldlapi.QueryEngine;
import de.derivo.sparqldlapi.QueryResult;
import de.derivo.sparqldlapi.exceptions.QueryEngineException;
import de.derivo.sparqldlapi.exceptions.QueryParserException;
import org.semanticweb.owlapi.apibinding.OWLManager;
import org.semanticweb.owlapi.model.IRI;
import org.semanticweb.owlapi.model.OWLOntology;
import org.semanticweb.owlapi.model.OWLOntologyCreationException;
import org.semanticweb.owlapi.model.OWLOntologyManager;
import org.semanticweb.owlapi.reasoner.OWLReasoner;
import org.semanticweb.owlapi.reasoner.OWLReasonerFactory;
import org.semanticweb.owlapi.reasoner.structural.StructuralReasonerFactory;

/**
 * Created by IntelliJ IDEA.
 * User: dodi
 * Date: 7/23/12
 * Time: 1:05 PM
 * To change this template use File | Settings | File Templates.
 */
public class SparqlJava {
    public static void main(String[] args) throws OWLOntologyCreationException, QueryParserException, QueryEngineException {
        // Create an ontology manager
        OWLOntologyManager manager= OWLManager.createOWLOntologyManager();
        // Load the wine ontology from the web.

        //val ont : OWLOntology = manager.loadOntologyFromOntologyDocument(IRI.create("http://www.w3.org/TR/owl-guide/wine.rdf"));

        // Create an instance of an OWL API reasoner (we use the OWL API built-in StructuralReasoner for the purpose of demonstration here)
        OWLReasonerFactory factory = new PelletReasonerFactory();
        OWLOntology owlont = manager.loadOntologyFromOntologyDocument(IRI.create("file:examples/simple2.owl"));
        OWLReasoner reasoner = factory.createReasoner(owlont);


        /*Query squery= Query.create("PREFIX simple: <http://www.semanticweb.org/dodi/ontologies/2012/8/untitled-ontology-6#>\n"+
                "SELECT ?i1 ?i2 WHERE {\n"
            +" Type(?i1,simple:Set), DifferentFrom(?i1, ?i2)}");*/

        Query squery2= Query.create("PREFIX simple: <http://www.semanticweb.org/dodi/ontologies/2012/8/untitled-ontology-6#>\n"+
                "SELECT * WHERE {\n"
                +"  DifferentFrom(<http://www.semanticweb.org/ontologies/2012/6/SHIP.owl#nil>, <http://www.semanticweb.org/ontologies/2012/6/SHIP.owl#nil>)}");

        QueryEngine engine = QueryEngine.create(manager, reasoner, true);
        QueryResult result = engine.execute(squery2);
        System.out.println(result);

    }
}
